package GUI::Scripts;
#<copyright>
# ----------------------------------------------------------
# Sun Proprietary/Confidential Code
# Copyright 2001, Sun Microsystems, Inc. All rights reserved.
# ----------------------------------------------------------
#</copyright>

use strict;
use System;
use Cache;
use PDM::ConfigFile;
use AutoForm;
use  Html::Tabs;
use Scheduler;

sub head {
  my($q) = @_;
  my ($out, @D, @L, $d);
  my $mach = Util->select_hosts("GUI::Scripts::command");

  my $head = Html->header("Run Scripts","90%",$mach, "run_scripts"); 
  $out = "\n<body bgcolor=$Style::BGCOLOR><center>$head";
  my $H =  System->get_home() . "/Scripts/";
  opendir(O, $H);
  my $cnt = 1;
  while ($d = readdir(O)) {
     next if (substr($d,0,1) eq "." || $d eq "CVS");
     if (-d "$H/$d") {
         $D[$cnt] = $d;
         push(@L, "$cnt=$d");
     }
  }
  closedir(O);
  $q->{option} = 1 if (!$q->{option});

  my $tab = Html::Tabs->create(list  =>  \@L,
                         url  => "$Http::WEBPROC?GO=GUI::Scripts::list",
                       width  => "90%",
               selectedColor  => "white",
           selectedTextColor  => "blue",
             backgroundColor  => $main'LIGHT,
          backgroundTextColor => 'black',
                    selection => $q->{option}
                 );
  
  return ($out . $tab, \@D);
}

sub man {
  my($q) = @_;
  my($l);
  print "\n<head><title>SE-Series Help</title></head><body bgcolor=white>";
  print "<table border=0 cellspacing=0 cellpadding=3 width=100% bgcolor=#DDDDFF>
   <tr><td><b>ManPage: $q->{page}
   </table>";

  $ENV{MANPATH} = "/opt/SUNWsecfg/man:/opt/SUNWrasag/man:/opt/SUNWvtsst/man";
  #open(O, System->get_home() . "/bin/seman $q->{page}|");
  open(O, "/usr/bin/man $q->{page}|");
  print "</center><pre>";
  my @x = <O>; close(O);
  my $text = join("", @x);
  $text = substr($text,1) if (substr($text,0,1) eq "\n");
  $text =~ s/</&lt;/g;
  $text =~ s/(_[_\w\- ]+_[\w\-])/&clean($1)/eg;
  $text =~ s/_//g;
  $text =~ s/\n\n/\n/g;
  print $text;
}
sub clean {
  my($v) = @_;
  $v =~ s/_//g;
  return "<b>$v</b>";
}
  


sub list {
  my($q) = @_;
  my($d);
  my ($head, $D) = &head($q);
  print $head;
  my $dir = $D->[$q->{option}];
  my($err,$af) = AutoForm->new("Scripts/$dir/config");
  print $err if ($err);

  my %CAT;
  foreach my $com (sort $af->commandList()) {
     next if ($com eq "GLOBAL");
     my $c = $af->commandByName($com);
     my $info = $c->info();
     my $url = "<a href=$Http::WEBPROC?GO=GUI::Scripts::command&option=$q->{option}&com=$com&dir=$dir>$com</a>";
     #$line = "<tr><td>&nbsp;<b>$info->{category}<td>&nbsp;$url<td>&nbsp;$info->{name}";

     push(@{$CAT{$info->{category}}}, [$info, $url, $com]);
  }
  print "
  <script>
  function fun1(a) {
   var b = '$Http::WEBPROC?GO=GUI::Scripts::man&page=' + a;
   var O = window.open(b, 'man','menubar=yes,resizable=yes,scrollbars=yes,width=500,height=600');
   O.focus();
  }
  </script>
  <table border=0><tr><td></table>
  <table border=1 width=90% bgcolor=white cellspacing=0 cellpadding=2>
  <tr bgcolor=$Style::DARK>
      <td><font color=white><b>Category
      <td><font color=white><b>Select Script</td>
      <td><font color=white><b>Description</td>
      <td><font color=white><b>LastRun</td>
      <td><font color=white><b>Live</td>
      <th><font color=white><b>ManPage</td>";
  my $last;
  foreach my $v (sort keys %CAT) {
    my $el = $CAT{$v};
    foreach my $el1 (@$el) {
      my $info = $el1->[0];
      if ($last ne $info->{category}) {
        print "<tr><td></td><tr><td>&nbsp;<b>$info->{category}";
        $last = $info->{category};
      } else {
        print "<tr><td></td>";
      }
      my $li = lc($info->{runlive}) eq "y"? "Y":"N";
      my $last = Cache->read("script_last_run", $el1->[2]);
      print "<td>&nbsp;$el1->[1]<td>&nbsp;$info->{name}<td>&nbsp;$last<td><center>$li<td><center>[ <a href=\"javascript:fun1('$el1->[2]')\">man</a> ]";
    }
  }
  print "</table>";
      
}

sub command {
  my($q) = @_;
  my($ad, $l);
  if ($q->{ACTION} =~ /Back/) {
      GUI::Scripts::list($q);
      return;
  }
  my ($head, $D) = &head($q);
  print $head;
  my $dir = $D->[$q->{option}];

  my($err,$af) = AutoForm->new("Scripts/$dir/config");
  my $c = $af->commandByName($q->{com});
  print "Cannot find script $c" if (!$c);
  my $info = $c->{info};

  if ($q->{ACTION} =~ /Run/) {
      my $dir = $q->{dir};
      my $prefix = uc(substr($dir,0,2));
      Cache->cache("script_last_run", $q->{com}, Util->get_today());
      my $com = $af->commandByName($q->{com});
      my($err, $test_command, $opts) = $af->makeCommand($q->{com}, $q);

      if (lc($com->info("runlive")) eq "y")  {
         open(O, "$test_command $opts|");
         print "</center><pre>";
         while ($l = <O>) {
            $l =~ s/</&lt;/;
            print $l;
         }
         close(O);
         return;
      } else {
        my($err,$pid) = Scheduler->run($prefix, undef, $test_command, $opts,  "", 0, "", 1, { } , 10);
      print "Script $q->{com} running, pid=$pid <br>";
      }

  }
  my($err, $upd) = $af->updateForm($q->{com}, {xheader => "", debug => 0}, {} );

   my($renv, $devs, $hosts, $notifs) = PDM::ConfigFile->read;
   my $host = "<select name=host><option>$renv->{hostname}";

   foreach my $h (@$hosts) {
      $host .= "<option>$h->{hostname}";
   }
   $host .= "</select>";

 #   <tr><td align=right bgcolor=$Style::LIGHT>Run on Host:&nbsp;<td>&nbsp;$host</td>

   print "
  <script>
  function fun1(a) {
   var b = '$Http::WEBPROC?GO=GUI::Scripts::man&page=' + a;
   var O = window.open(b, 'man','menubar=yes,resizable=yes,scrollbars=yes,width=600,height=600');
   O.focus();
  }
  </script>
<table border=0><tr><td> <form>
       <input type=hidden name=GO value=GUI::Scripts::command>
       <input type=hidden name=com value=\"$q->{com}\">
       <input type=hidden name=dir value=\"$q->{dir}\">
       <input type=hidden name=option value=\"$q->{option}\">
   </table>
   <table border=1 width=90%  bgcolor=white cellspacing=0 cellpadding=3>
    <tr><td colspan=2 bgcolor=$Style::DARK>
      <table border=0 cellspacing=0 width=100%>
        <tr><td><font color=white><b>&nbsp;Script<big> $q->{com}</td>
            <td align=right><font color=white><b>[ <a href=\"javascript:fun1('$q->{com}')\"><font color=white>ManPage</font></a> ]</td></table>
    <tr><td align=right bgcolor=$Style::LIGHT>Name:&nbsp;<td>&nbsp;$info->{name}</td>
    $upd
   </table>
   <table border=0><tr><td></table><b>
   <input type=submit name=ACTION value=\"Run Script\">
   <input type=submit name=ACTION value=\"Back to List\">
   </form> ";
}



1;
