package MG::Telnet;
#<copyright>
# ----------------------------------------------------------
# Sun Proprietary/Confidential Code
# Copyright 2001, Sun Microsystems, Inc. All rights reserved.
# ----------------------------------------------------------
#</copyright>
#  $Id: Telnet.pm,v 1.3 2004/09/28 21:20:04 ccadieux Exp $

use PDM::ConfigFile;
use Net::Telnet;
use Labels;
use strict;
use Html;

use vars qw(%CONN);

######################################################
#                     TELNET
######################################################

sub menu {
  my($q) = @_;
  print Html->body();
  my $LB = Labels->read("Service::Util")->section("telnet");

  if ($q->{ACTION_start}) {
     my ($cat, $ipno)  = split(/\:/, $q->{ip});
     if (!$ipno) {
        print Html->error("No device was selected!");
     } elsif (Util->ping($ipno)) {
        &telnet2($q);
        return;
     } else {
        print Html->error("Cannot ping $ipno");
     }
  }

  my($renv, $devs, $hosts, $notifs) = PDM::ConfigFile->read();
  my $list;
  my $cat = $q->{cat};
  my $cnt=0;
  my $lastdev;
  foreach my $dev (@$devs) {
     if (index(",6020,6120,dsp,t3,3310,sve2", $dev->{type}) >= 0) {
        next if ($cat && $dev->{type} ne $cat);
        $list .= "$dev->{type}:$dev->{ipno}:$dev->{name}=$dev->{name}|";
        $cnt++;
        $lastdev = $dev;
     }
  }
  $list .= "host:localhost:$renv->{hostname}=Host $renv->{hostname}";

  print Html->header2("manage.util.telnet");
     
  my $select = Util->makeSelect("ip", $list);

  print <<EOF;
<table border=1 cellspacing=0 cellpadding=2 bgcolor=white width=90%>
  <tr><td align=right bgcolor=$Style::LIGHT>
      <form method=post><input type=hidden name=GO value=MG::Telnet::menu>
         $LB->{dev}:</td>
      <td>$select
  <tr><td align=right bgcolor=$Style::LIGHT>$LB->{login}:</td>
      <td><input type=text name=login size=20 value=root>

  <tr><td align=right bgcolor=$Style::LIGHT>Password:</td>
      <td><input type=password name=password size=20 value=\"\">

  </table><b>
  <input type=submit name=ACTION_start value=\"$LB->{connect}\">
</form>
EOF
   
}

# $q = { ipno => "cat:ipno:name", login => "login", password => "password" }

sub telnet2 {
  my($q) = @_;

  my $help = "[ <a href=\"javascript:win2()\">Help</a> ]" if ($q->{help});
  my $ipno  = $q->{ip};
  my($cat, $x, $name) = split(/\:/, $ipno);

  my $LB = Labels->read("Service::Util")->section("telnet");

  my $login = $q->{login};
  my $pass  = Util->encodeAll($q->{password});

  my $rem = $ENV{REMOTE_USER} || $cat || "U1";

  foreach my $e (keys %CONN) {
     my $v = $CONN{$e};
     if (time - $v->{last_activity} > (2*60*60)) {
        my $con = $CONN{$e}{con};
        my @out = $con->cmd("exit");
        delete $CONN{$e};
     }
  }

  if ($CONN{$rem}) { # disconnect for now
      my $con = $CONN{$rem}{con};
      my @out = $con->cmd("exit");
      delete $CONN{$rem};
  }

  my ($last, $request);
  print Html->body();

  print Html->header2("manage.util.telnet", "97%");

  my $code = "Telnet";
  my $applet = System->appletHeader("code=telnetApplet.class codebase=$code" , 50,60);
  my $rashttp = "rashttp"; # Http->getRashttpName();
   print <<EOF;
<table border=0 cellspacing=0 cellpadding=0 bgcolor=white><tr><td>
<font color=red><b>$LB->{warning}</b>
</table>

<table border=0 cellpadding=2 bgcolor=$Style::DARK width=97%>
  <tr><td><font color=white><b>&nbsp;$name ($x) / $login
</table>
<table border=0 cellspacing=0 width=95%><tr><td><center>
$applet
 <param name=url value="GO=MG::Telnet::run">
 <param name=rashttp value="$rashttp">
 <param name=info value="&ip=$ipno&login=$login&password=$pass">
 <param name=live value="Y">
</applet>
</table>
EOF

}
sub log1 {
  my($v) = @_;
  open(OO, ">>/tmp/xx"); print OO "$v,\n"; 
  close(OO);
}

sub run {
  my($q) = @_;
  my ($cat, $ipno, $name)  = split(/\:/, $q->{ip});
  my $login = $q->{login};
  my $pass  = Util->decode($q->{password});
  my ($last, $request);
  #print "HTTP/1.0 200 OK\n\n";

  my $rem = $ENV{REMOTE_USER} || $cat || "U1";
  my $cnt;
  while (1) {
      $request = $q->{command};
      if ($request =~ /^\s+$/) {
         print "Enter command!\n";
         last;
      }

      if (!$CONN{$rem}) {
         print "#new connection\n";
         my $t;
         if (index(",host,", $cat) >= 0) {
            $t  = Net::Telnet->new(
              errmode => "return",
              Timeout   => 6,
              Prompt    => '/\]\$ $/'
               );
         } elsif (index(",6020,6120,t3,", $cat) >= 0) {
            $t  = Net::Telnet->new(
              errmode => "return",
              Timeout   => 10,
              Prompt    => '/<\d+\>/'
               );
         } elsif (index(",dsp,sve2,", $cat) >= 0) {
            $t  = Net::Telnet->new(
              errmode => "return",
              Timeout   => 10,
              Prompt    =>  '/([#?] $|\033\[\dD )/',
               );
         }

         if (!defined($t->open($ipno))) {
            print "ERR: Cannot open $ipno\n";
            last;
         }
         $t->login($login, $pass);
         if ($t->errmsg()) {
              print "ERR: " . $t->errmsg() . "\n";
              delete $CONN{$rem};
              next if ($cnt++ < 2);
              last;
         }
         $CONN{$rem}{con} = $t;
         $CONN{$rem}{id}  = $q->{ip};
         $CONN{$rem}{last_connect} = time;
         if ($cat eq "sve2") {
            my @out  = $t->cmd("no page-mode");
            my @out  = $t->cmd("terminal width 110");
         }
      }
      my $conn = $CONN{$rem}{con};
      my @out;
      if (lc($request) eq " m") {
        print "#Invalid remote command!\n";
      } elsif (lc($request) =~ "^ more") {
        print "#Invalid remote command!\n";

      } elsif ($request eq " EXIT") {
         if ($cat eq "host") {
            @out  = $conn->cmd("exit");
         }
         $conn->close();
         delete $CONN{$rem};
         print "# Bye\n";

      } else {  # normal command
        if ($cat eq "sve2") {
          @out  = $conn->cmd($request);
          if ("@out" =~ /Error: Invalid para/) {
            $conn->cmd("^U");
            $conn->cmd("^U");
          }
        } else {
          @out  = $conn->cmd($request);
        }
        $CONN{$rem}{last_activity} = time;
      }

      print join("",@out);
      last;
  }
}


1;
