package TO::SP;
#<copyright>
# ----------------------------------------------------------
# Sun Proprietary/Confidential Code
# Copyright 2001, Sun Microsystems, Inc. All rights reserved.
# ----------------------------------------------------------
#</copyright>

use base 'TO::Server';
use strict;

sub leaf { 1 }
sub type { "sp"}

sub new {
  my($class, $Topo, $hostname) = @_;
  my($size);
  my($name)  = "sp:$hostname";
  my($hosts) = $Topo->[0];
  my $syns   = $Topo->[4];
  my $renv = System->get_renv();
  my $mgmtLevel =  "C";

  if (!defined($hosts->{$name}) ) {
     my($obj) = {};
     $obj->{info}{type}    = "Sun";
     $obj->{info}{class}   = "server.sp";
     $obj->{info}{hostid}  = System->hostid();
     $obj->{info}{ipno}    = Util->name2ip($hostname);
     $obj->{info}{bitMode} = System->bitMode();
     $obj->{info}{model}   = System->model();
     $obj->{info}{release} = System->os_version();
     $obj->{info}{mgmtLevel} = $mgmtLevel;
     $obj->{info}{name} = $name;
     $obj->{portInfo}   = [];
     $obj->{port}       = [];
     bless($obj, 'TO::SP');
     $hosts->{$name} = $obj;
     $syns->{$hostname} = $name;
  }
  return $hosts->{$name};
}

sub addFromConfig {
  my($class, $topo, $Config) = @_;
  my $renv = System->get_renv();

  $class->new($topo, $renv->{hostname});
  return undef;

}


sub statusFunc {
  my($class, $name, $State) = @_;

  my $Comp = $State->components($name);
  my $i   = $Comp->value("e");
  my ($enc, $encInfo);
  my ($other, $disk, $diskInfo, $otherInfo, $port, $portInfo);

  my (@P, $x);
  foreach my $c (keys %$Comp) {
     $Comp->summ($c, \$other, \$otherInfo);
  }

  return ($enc, $port, $disk, $other, $encInfo,
          $portInfo, $diskInfo, $otherInfo);

}

sub iconLayout {
  my($ho) = @_;
  return "E0E0E0/netraX1.gif,_," ; 
}



1;
